package de.unikoblenz.fgbks.core.dmn.domain.vdmn;

import de.unikoblenz.fgbks.core.dmn.domain.common.RowNumber;
import de.unikoblenz.fgbks.core.dmn.domain.ids.DecisionId;
import de.unikoblenz.fgbks.core.dmn.domain.ids.DecisionTableId;
import de.unikoblenz.fgbks.core.dmn.domain.ids.DefinitionId;
import de.unikoblenz.fgbks.core.dmn.domain.ids.RuleId;

public interface VDmnValue extends VDmnElement {

  VDmnRule getDmnRule();

  String getText();

  String getDescription(); // TODO: MAKE VALUE OBJECT

  VDmnColumn getDmnColumn();

  default DefinitionId getDefinitionId() {
    return getDmnColumn().getDmnDecisionTable().getDecision().getDmnDefinition().getDefinitionId();
  }

  default DecisionId getDecisionId() {
    return getDmnColumn().getDmnDecisionTable().getDecision().getDecisionId();
  }

  default DecisionTableId getDecisionTableId() {
    return getDmnColumn().getDmnDecisionTable().getDecisionTableId();
  }

  default VTypeRef getTypeRef() {
    return getDmnColumn().getTypeRef();
  }

  default RuleId getRuleId() {
    return getDmnRule().getRuleId();
  }

  default RowNumber getRowNumber() {
    return getDmnRule().getRowNumber();
  }

  default boolean isInputValue() {
    return getDmnColumn() instanceof VDmnInputColumn;
  }

  default boolean isOutputValue() {
    return getDmnColumn() instanceof VDmnOutputColumn;
  }
}
