package de.unikoblenz.fgbks.core.dmn.domain.vdmn.impl;

import de.unikoblenz.fgbks.core.dmn.domain.ids.OutputEntryId;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnOutputColumn;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnOutputValue;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnRule;
import org.apache.commons.lang3.Validate;

public class VDmnOutputValueImpl extends VDmnValueImpl implements VDmnOutputValue {

  private VDmnOutputValueImpl() {}

  public static Builder getBuilder() {
    return new VDmnOutputValueImpl().new Builder();
  }

  public class Builder extends DmnElementBuilder<VDmnOutputValueImpl> {

    public Builder withOutputEntryId(OutputEntryId outputEntryId) {
      value.id = outputEntryId;
      return this;
    }

    public Builder withDmnRule(VDmnRule dmnRule) {
      value.dmnRule = dmnRule;
      return this;
    }

    public Builder withText(String text) {
      value.text = text;
      return this;
    }

    public Builder withDescription(String description) {
      value.description = description;
      return this;
    }

    public Builder withDmnOutputColumn(VDmnOutputColumn dmnColumn) {
      value.dmnColumn = dmnColumn;
      return this;
    }

    @Override
    protected void validate() {
      super.validate();
      Validate.notNull(value.id);
      Validate.notNull(value.dmnRule);
      Validate.notNull(value.text);
      Validate.notNull(value.dmnColumn);
    }
  }
}
