package de.unikoblenz.fgbks.core.dmn.verification.result;

import de.unikoblenz.fgbks.base.builder.DefaultBuilder;
import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import javax.json.bind.annotation.JsonbProperty;
import org.apache.commons.lang3.Validate;

public class VerifierResultSet extends AbstractResultObject {

  private Set<VerifierResult> verifierResults;

  protected VerifierResultSet() {
    this.verifierResults = ConcurrentHashMap.newKeySet();
  }

  @JsonbProperty("verifier")
  public Set<VerifierResult> getVerifierResults() {
    return new HashSet<>(verifierResults);
  }

  @JsonbProperty("size")
  public int getAmountOfVerifier() {
    return verifierResults.size();
  }

  private void addVerifierResult(VerifierResult verifierResult) {
    verifierResults.add(verifierResult);
  }

  public static Builder getBuilder() {
    return new VerifierResultSet().new Builder();
  }

  public class Builder extends DefaultBuilder<VerifierResultSet> {

    public Builder addVerifierResult(VerifierResult verifierResult) {
      value.addVerifierResult(Validate.notNull(verifierResult));
      return this;
    }
  }
}
